label .t.version -text {Recursive Lexical Rules}
pack .t.version -side right

prolog {send_boolean_flag add_mod}
prolog {send_boolean_flag push_to_slash}
prolog {send_boolean_flag push_to_extra}

.menu.grammar.m add cascade -label "Change Flags" -menu .menu.grammar.flag

menu .menu.grammar.flag
.menu.grammar.flag add check -label add_mod\
      -variable flag(add_mod)\
     -command "change_boolean_flag add_mod"

.menu.grammar.flag add check -label push_to_slash \
     -variable flag(push_to_slash)\
     -command "change_boolean_flag push_to_slash"

.menu.grammar.flag add check -label push_to_extra \
     -variable flag(push_to_extra)\
     -command "change_boolean_flag push_to_extra"

.menu.grammar.m add cascade -label "View Lexical Hierarchy"\
	-menu .menu.grammar.lh

.menu.grammar.m add cascade -label "View Part of Hierarchy"\
	-menu .menu.grammar.lhp

menu .menu.grammar.lh

.menu.grammar.lh add command -label "Tk" -command {
    prolog call_tree_bu_tk
}
.menu.grammar.lh add command -label "Tex" -command {
    prolog call_tree_bu_latex
}
.menu.grammar.lh add command -label "Prolog" -command {
    prolog call_tree_bu
}

menu .menu.grammar.lhp

.menu.grammar.lhp add command -label "Tk" -command {
    prolog "ct tk \
               [SP_qbox .w unary_preds {Lexical Type} {Lexical Type}]"
}
.menu.grammar.lhp add command -label "Tex" -command {
    prolog "ct latex \
               [SP_qbox .w unary_preds {Lexical Type} {Lexical Type}]"
}
.menu.grammar.lhp add command -label "Prolog" -command {
    prolog "ct prolog \
               [SP_qbox .w unary_preds {Lexical Type} {Lexical Type}]"
}


#proc SP_call_tree {} {
#      prolog "call_tree_bu_tk [SP_question .w "Lexical Type" \
#         "Lexical Type to show" {}]"
#}

.menu.help.m add command -label "About the grammar" -underline 0\
               -command GrammarInfo

proc GrammarInfo {} {
    tk_dialog .d "About the Grammar" "
	This grammar is written by G. van Noord. It is a \
	head-driven unification grammar for Dutch in which\
	powerful recursive lexical rules are used. The\
	approach is desribed in the paper `Adjuncts and the\
	processing of lexical rules', co-authored with Gosse\
	Bouma, which will appear in the Proceedings of Coling\
	1994." "" 0 ok
}


